"""add reason table

Revision ID: a141afacffd3
Revises: ba9c3fbefbf8
Create Date: 2022-03-13 20:37:47.369021

"""
import sqlalchemy as sa

from alembic import op

# revision identifiers, used by Alembic.
revision = "a141afacffd3"
down_revision = "ba9c3fbefbf8"
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table(
        "reasons",
        sa.Column("id", sa.Integer(), sa.Identity(always=False), nullable=False),
        sa.Column(
            "created_at", sa.DateTime(), server_default=sa.text("now()"), nullable=True
        ),
        sa.Column(
            "updated_at", sa.DateTime(), server_default=sa.text("now()"), nullable=True
        ),
        sa.Column("deleted_at", sa.DateTime(), nullable=True),
        sa.Column("deleted", sa.Boolean(), nullable=True),
        sa.Column("reason", sa.Text(), nullable=False),
        sa.PrimaryKeyConstraint("id"),
        sa.UniqueConstraint("reason"),
    )
    op.add_column("tickets", sa.Column("reason_id", sa.Integer(), nullable=True))
    op.create_foreign_key(
        None, "tickets", "reasons", ["reason_id"], ["id"], ondelete="SET NULL"
    )
    op.drop_column("tickets", "reason")
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.add_column(
        "tickets", sa.Column("reason", sa.VARCHAR(), autoincrement=False, nullable=True)
    )
    op.drop_constraint(None, "tickets", type_="foreignkey")
    op.drop_column("tickets", "reason_id")
    op.drop_table("reasons")
    # ### end Alembic commands ###
